Subject: Re: [PATCH net] igb: cope with large MAX_SKB_FRAGS.

From: Maciej Fijalkowski <[email-masked]>
Date: Mon, 12 Aug 2024 14:47:26 +0200

On Fri, Aug 09, 2024 at 02:16:20PM +0200, Corinna Vinschen wrote:
> On Aug  8 20:20, Maciej Fijalkowski wrote:
> > On Wed, Aug 07, 2024 at 06:09:20PM +0200, Maciej Fijalkowski wrote:
> > > On Tue, Aug 06, 2024 at 03:15:31PM -0700, Tony Nguyen wrote:
> > > > diff --git a/drivers/net/ethernet/intel/igb/igb_main.c b/drivers/net/ethernet/intel/igb/igb_main.c
> > > > index 11be39f435f3..232d6cb836a9 100644
> > > > --- a/drivers/net/ethernet/intel/igb/igb_main.c
> > > > +++ b/drivers/net/ethernet/intel/igb/igb_main.c
> > > > @@ -4808,6 +4808,7 @@ static void igb_set_rx_buffer_len(struct igb_adapter *adapter,
> > > >  
> > > >  #if (PAGE_SIZE < 8192)
> > > >  	if (adapter->max_frame_size > IGB_MAX_FRAME_BUILD_SKB ||
> > > > +	    SKB_HEAD_ALIGN(adapter->max_frame_size) > (PAGE_SIZE / 2) ||
> > > 
> > > We should address IGB_2K_TOO_SMALL_WITH_PADDING for this case. I'll think
> > > about it tomorrow.
> > 
> > Actually from what I currently understand IGB_2K_TOO_SMALL_WITH_PADDING
> > will give us 'true' for case you are addressing so we could reuse it here?
> 
> Well, IGB_2K_TOO_SMALL_WITH_PADDING is a constant expression evaluated
> at build time.  The SKB_HEAD_ALIGN expression is dynamically computed,
> basically depending on the MTU.
> 
> IGB_2K_TOO_SMALL_WITH_PADDING switches from false to true with
> MAX_SKB_FRAGS set to 22 or more.
> 
> So with MAX_SKB_FRAGS set to 17, IGB_2K_TOO_SMALL_WITH_PADDING is false,
> while the SKB_HEAD_ALIGN expression is true for MTUs >= 1703.

MTU >= 1703 will trigger the current adapter->max_frame_size >
IGB_MAX_FRAME_BUILD_SKB statement.

> 
> With MAX_SKB_FRAGS set to 45, IGB_2K_TOO_SMALL_WITH_PADDING is true,
> the SKB_HEAD_ALIGN expression is true for MTUs >= 1255.
> 
> Given that, IGB_2K_TOO_SMALL_WITH_PADDING might be the more careful
> check.  Do you want me to send a v2?

Using IGB_2K_TOO_SMALL_WITH_PADDING here aligns it with igb_skb_pad() when
computing headroom, so if you don't mind maybe it will be cleaner to reuse
it?

> Thanks,
> Corinna